Class | Zlib::ZStream
In: | zlib/zlib.c
Parent: | Object

Zlib::ZStream is the abstract class for the stream which handles the compressed data. The operations are defined in the subclasses: Zlib::Deflate for compression, and Zlib::Inflate for decompression.

An instance of Zlib::ZStream has one stream (struct zstream in the source) and two variable-length buffers which associated to the input (next_in) of the stream and the output (next_out) of the stream. In this document, "input buffer" means the buffer for input, and "output buffer" means the buffer for output.

Data input into an instance of Zlib::ZStream are temporally stored into the end of input buffer, and then data in input buffer are processed from the beginning of the buffer until no more output from the stream is produced (i.e. until avail_out > 0 after processing). During processing, output buffer is allocated and expanded automatically to hold all output data.

Some particular instance methods consume the data in output buffer and return them as a String.

Here is an ascii art for describing above:

       +================ an instance of Zlib::ZStream ================+
       ||                                                            ||
       ||     +--------+          +-------+          +--------+      ||
       ||  +--| output |<---------|zstream|<---------| input  |<--+  ||
       ||  |  | buffer |  next_out+-------+next_in   | buffer |   |  ||
       ||  |  +--------+                             +--------+   |  ||
       ||  |                                                      |  ||
       +===|======================================================|===+
           |                                                      |
           v                                                      |
       "output data"                                         "input data"

If an error occurs during processing input buffer, an exception which is a subclass of Zlib::Error is raised. At that time, both input and output buffer keep their conditions at the time when the error occurs.

## Method Catalogue

Many of the methods in this class are fairly low-level and unlikely to be of interest to users. In fact, users are unlikely to use this class directly; rather they will be interested in Zlib::Inflate and Zlib::Deflate.

The higher level methods are listed below.

- total_in
- total_out
- data_type
- adler
- reset
- finish
- finished?
- close
- closed?

### Methods

adler avail_in avail_out avail_out= close closed? data_type end ended? finish finished? flush_next_in flush_next_out reset stream_end? total_in total_out

### Public Instance methods

adler()

Returns the adler-32 checksum.

[Source]

    /*
     * Returns the adler-32 checksum.
     */
    static VALUE
    rb_zstream_adler(obj)
        VALUE obj;
    {
    	return rb_uint2inum(get_zstream(obj)->stream.adler);
    }

avail_in()

Returns bytes of data in the input buffer. Normally, returns 0.

[Source]

    /*
     * Returns bytes of data in the input buffer. Normally, returns 0.
     */
    static VALUE
    rb_zstream_avail_in(obj)
        VALUE obj;
    {
        struct zstream *z;
        Data_Get_Struct(obj, struct zstream, z);
        return INT2FIX(NIL_P(z->input) ? 0 : (int)(RSTRING(z->input)->len));
    }

avail_out()

Returns number of bytes of free spaces in output buffer. Because the free space is allocated automatically, this method returns 0 normally.

[Source]

    /*
     * Returns number of bytes of free spaces in output buffer.  Because the free
     * space is allocated automatically, this method returns 0 normally.
     */
    static VALUE
    rb_zstream_avail_out(obj)
        VALUE obj;
    {
        struct zstream *z;
        Data_Get_Struct(obj, struct zstream, z);
        return rb_uint2inum(z->stream.avail_out);
    }

avail_out=(p1)

Allocates `size` bytes of free space in the output buffer. If there are more than `size` bytes already in the buffer, the buffer is truncated. Because free space is allocated automatically, you usually don’t need to use this method.

[Source]

    /*
     * Allocates +size+ bytes of free space in the output buffer. If there are more
     * than +size+ bytes already in the buffer, the buffer is truncated. Because
     * free space is allocated automatically, you usually don't need to use this
     * method.
     */
    static VALUE
    rb_zstream_set_avail_out(obj, size)
        VALUE obj, size;
    {
        struct zstream *z = get_zstream(obj);

        Check_Type(size, T_FIXNUM);
        zstream_expand_buffer_into(z, FIX2INT(size));
        return size;
    }

close()

Closes the stream. All operations on the closed stream will raise an exception.

[Source]

    /*
     * Closes the stream. All operations on the closed stream will raise an
     * exception.
     */
    static VALUE
    rb_zstream_end(obj)
        VALUE obj;
    {
        zstream_end(get_zstream(obj));
        return Qnil;
    }

closed?()

Returns true if the stream is closed.

[Source]

    /*
     * Returns true if the stream is closed.
     */
    static VALUE
    rb_zstream_closed_p(obj)
        VALUE obj;
    {
        struct zstream *z;
        Data_Get_Struct(obj, struct zstream, z);
        return ZSTREAM_IS_READY(z) ? Qfalse : Qtrue;
    }

data_type()

Guesses the type of the data which have been inputed into the stream. The returned value is either `Zlib::BINARY`, `Zlib::ASCII`, or `Zlib::UNKNOWN`.

[Source]

    /*
     * Guesses the type of the data which have been inputed into the stream. The
     * returned value is either <tt>Zlib::BINARY</tt>, <tt>Zlib::ASCII</tt>, or
     * <tt>Zlib::UNKNOWN</tt>.
     */
    static VALUE
    rb_zstream_data_type(obj)
        VALUE obj;
    {
        return INT2FIX(get_zstream(obj)->stream.data_type);
    }

end()

Closes the stream. All operations on the closed stream will raise an exception.

[Source]

    /*
     * Closes the stream. All operations on the closed stream will raise an
     * exception.
     */
    static VALUE
    rb_zstream_end(obj)
        VALUE obj;
    {
        zstream_end(get_zstream(obj));
        return Qnil;
    }

ended?()

Returns true if the stream is closed.

[Source]

    /*
     * Returns true if the stream is closed.
     */
    static VALUE
    rb_zstream_closed_p(obj)
        VALUE obj;
    {
        struct zstream *z;
        Data_Get_Struct(obj, struct zstream, z);
        return ZSTREAM_IS_READY(z) ? Qfalse : Qtrue;
    }

finish()

Finishes the stream and flushes output buffer. See Zlib::Deflate#finish and Zlib::Inflate#finish for details of this behavior.

[Source]

    /*
     * Finishes the stream and flushes output buffer. See Zlib::Deflate#finish and
     * Zlib::Inflate#finish for details of this behavior.
     */
    static VALUE
    rb_zstream_finish(obj)
        VALUE obj;
    {
        struct zstream *z = get_zstream(obj);
        VALUE dst;

        zstream_run(z, "", 0, Z_FINISH);
        dst = zstream_detach_buffer(z);

        OBJ_INFECT(dst, obj);
        return dst;
    }

finished?()

Returns true if the stream is finished.

[Source]

    /*
     * Returns true if the stream is finished.
     */
    static VALUE
    rb_zstream_finished_p(obj)
        VALUE obj;
    {
        return ZSTREAM_IS_FINISHED(get_zstream(obj)) ? Qtrue : Qfalse;
    }

flush_next_in()

Flushes input buffer and returns all data in that buffer.

[Source]

    /*
     * Flushes input buffer and returns all data in that buffer.
     */
    static VALUE
    rb_zstream_flush_next_in(obj)
        VALUE obj;
    {
        struct zstream *z;
        VALUE dst;

        Data_Get_Struct(obj, struct zstream, z);
        dst = zstream_detach_input(z);
        OBJ_INFECT(dst, obj);
        return dst;
    }

flush_next_out()

Flushes output buffer and returns all data in that buffer.

[Source]

    /*
     * Flushes output buffer and returns all data in that buffer.
     */
    static VALUE
    rb_zstream_flush_next_out(obj)
        VALUE obj;
    {
        struct zstream *z;
        VALUE dst;

        Data_Get_Struct(obj, struct zstream, z);
        dst = zstream_detach_buffer(z);
        OBJ_INFECT(dst, obj);
        return dst;
    }

reset()

Resets and initializes the stream. All data in both input and output buffer are discarded.

[Source]

    /*
     * Resets and initializes the stream. All data in both input and output buffer
     * are discarded.
     */
    static VALUE
    rb_zstream_reset(obj)
        VALUE obj;
    {
        zstream_reset(get_zstream(obj));
        return Qnil;
    }

stream_end?()

Returns true if the stream is finished.

[Source]

    /*
     * Returns true if the stream is finished.
     */
    static VALUE
    rb_zstream_finished_p(obj)
        VALUE obj;
    {
        return ZSTREAM_IS_FINISHED(get_zstream(obj)) ? Qtrue : Qfalse;
    }

total_in()

Returns the total bytes of the input data to the stream. FIXME

[Source]

    /*
     * Returns the total bytes of the input data to the stream.  FIXME
     */
    static VALUE
    rb_zstream_total_in(obj)
        VALUE obj;
    {
        return rb_uint2inum(get_zstream(obj)->stream.total_in);
    }

total_out()

Returns the total bytes of the output data from the stream. FIXME

[Source]

    /*
     * Returns the total bytes of the output data from the stream.  FIXME
     */
    static VALUE
    rb_zstream_total_out(obj)
        VALUE obj;
    {
        return rb_uint2inum(get_zstream(obj)->stream.total_out);
    }

[Validate]